# M3U8_MERGE

## Dependencies
	python3

-   Centos
-   sudo yum install python3
-
-   Ubuntu
-   sudo apt-get install python3

### Python 3 dependencies
-sortedcontainers
-pip3 install sortedcontainers

## Using M3U8_MERGE

-   In the single-stream recording mode, the audio and video data of each user (UID) are recorded separately. You can use a merge script to merge the audio and video files.
    
### Directions 
    1. Run the merge script: python3 trtc_merge.py [option] 
    2. An MP4 file will be generated in the directory of the original recording files.
> For example: python3 trtc_merge.py -f /xxx/file -m 0 
     
-   See the table below for valid parameters for [option].

|Parameter| Description |
|--|--|
|-f | The directory of the recording files to merge. If there are recording files for multiple users (UIDs), they will all be transcoded.|
|-m   | `0` (default): Section-based merge. In this mode, the recording files of each user (UID) are merged based on the recording section.<br>`1`: User-based merge. In this mode, the recording files of each user (UID) are merged into one file.|
|-s| Whether to delete the blank parts between recording sections in the user-based merge mode. If they are deleted, the files generated will be shorter than the recording duration.|
|-a|`0` (default): Disable the substream; `1`: Use the substream if there isn’t a primary stream; `2`: Disable the primary stream.|
|-p|The frame rate (fps) of the output video, which is `15` by default. Value range: 5-120. If you enter a value smaller than `5`, `5` will be used; if you enter a value greater than `120`, `120` will be used.|
|-r|The resolution of the output video. For example, `-r 640 360` indicates that the resolution of the output video is 640 x 360. |

### Concepts  
> If two TS segments are more than 15 seconds apart, during which no audio or video data is recorded (if the substream is disabled, its data will be ignored), the two TS segments will be considered to belong to different recording sections, one being the ending TS segment of the previous section, and the other the starting TS segment of the next section.

 - Section-based merge (`-m 0`)
In this mode, the recording files of each user (UID) are merged based on the recording section. One file is generated for each recording section.
            
- User-based merge (`-m 1`)
In this mode, all the recording sections of each user (UID) are merged into one file. You can use `-s` to specify whether to delete the blank parts between sections.

### Naming of the files generated
Audio/Video file: uid_timestamp_av.mp4

Audio-only file: uid_timestamp.m4a

`uid` identifies a user, and `timestamp` indicates the recording start time.
